/* a line graph program for the ega */
/* written in MIX POWER C Large Model by Bill Buckels */
/* 1991 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <dos.h>
#include <bios.h>
#include <io.h>
#include <malloc.h>
#include <conio.h>

#define BLACK     0
#define BLUE      1
#define GREEN     2
#define CYAN      3
#define RED       4
#define MAGENTA   5
#define BROWN     6
#define WHITE     7
#define GRAY      8
#define LBLUE     9
#define LGREEN    10
#define LCYAN     11
#define LRED      12
#define LMAGENTA  13
#define YELLOW    14
#define BWHITE    15



#define EGA  '\x10'
#define TEXT '\x03'

unsigned char setcrtmode(unsigned char vidmode)
{
    union REGS inregs, outregs;

    /* set mode */
    inregs.h.ah = 0;
    inregs.h.al = vidmode;
    int86( 0x10, &inregs, &outregs );

    /* get mode */
    inregs.h.ah = 0xf;
    int86( 0x10, &inregs, &outregs );

    /* return mode */
    return outregs.h.al;

}

void flood(unsigned char floodcolor)
{
    union REGS rin,rout;

    rin.h.dh =43;
    rin.h.dl =79;
    rin.x.cx = 0;
    rin.h.bh= floodcolor;
    rin.x.ax= 0x0600;
    int86(0x10,&rin,&rout);
}


void writepixel(unsigned x, unsigned y, unsigned color)
{
   union REGS reg;

   reg.h.ah = 0x0c;
   reg.h.al = (char )color;
   reg.h.bh = 0;
   reg.x.cx = x;
   reg.x.dx = y;

   int86(0x10,&reg,&reg);

}


void linebox(int x1, int y1, int x2, int y2,unsigned tempcolor)
{
    register x,y;

    x2++;
    x=x1;
    y=y1;
    while(x<x2)
    {
      writepixel(x,y,tempcolor);
      x++;
    }
    y++;
    x2--;
    while(y<y2)
    {
        writepixel(x1,y,tempcolor);
        writepixel(x2,y,tempcolor);
        y++;
        }

     x2++;
     x=x1;
     while(x<x2)
    {
      writepixel(x,y,tempcolor);
      x++;
    }

}


void writeline(int x1,int y1,int x2,int y2,unsigned color)
{
    union REGS inregs, outregs;
    #define sign(x) ((x)>0?1:((x)==0?0:(-1)))
    int dx,dy,dxabs,dyabs,i,px,py,sdx,sdy,x,y;

     inregs.h.ah = 0x0c;
     inregs.h.al = (char )color;
     inregs.h.bh = 0;


    dx=x2-x1;
    dy=y2-y1;
    sdx=sign(dx);
    sdy=sign(dy);
    dxabs=abs(dx);
    dyabs=abs(dy);
    x=0;
    y=0;
    px=x1;
    py=y1;

    if(dxabs >= dyabs)
    {
        for(i=0;i<=dxabs;i++)
        {
            y+=dyabs;
            if(y>=dxabs)
            {y-=dxabs;
             py+=sdy;
            }
            inregs.x.cx = px;
            inregs.x.dx = py;
            int86(0x10,&inregs,&outregs);
            px+=sdx;
        }
    }
    else{
        for(i=0;i<=dyabs;i++)
        {
            x+=dxabs;
            if(x>=dyabs)
            {
                x-=dyabs;
                px+=sdx;
            }
            inregs.x.cx = px;
            inregs.x.dx = py;
            int86(0x10,&inregs,&outregs);
            py+=sdy;
        }
    }
}


#define CRETURN '\x0d'

int egatext(char *str, unsigned x, unsigned y, unsigned colorvalue)
{

    union REGS inregs, outregs;

    int scanline,byte,character,nibble;   /* flags etcetera */
    int counter;
    unsigned char *romfont=(unsigned char *) 0xffa6000el;
    /* a pointer to the 8 x 8 BITMAPPED font in the PC ROM    */

    int target = strlen(str);  /* string length               */

    if(!target)return 0;
    for(counter=0;counter<target;counter++){
        if(str[counter]<' '||str[counter]>'z')str[counter]=0;
        if(str[counter]==CRETURN)target=counter;
        }

     inregs.h.ah = 0x0c;
     inregs.h.al = (char )colorvalue;
     inregs.h.bh = 0;



    for (scanline=0;scanline<8;scanline++) /* finish the current scanline
                                              before advancing to the next */
    {
     for (byte=0;byte<target;byte++)         /* run the scanline           */
     {                                       /* use the current character
                                                as an indices for the font */
      character = romfont[(str[byte]&0x7f)*8+scanline];
      if (character != 0)
          for (nibble=0;nibble<8;nibble++)
              if (character & 0x80>>nibble)
                       {
                         inregs.x.cx = x+byte*8+nibble;
                         inregs.x.dx = y;
                         int86(0x10,&inregs,&outregs);
                        }
        }

     y++;
    }
    return target;

}


/* center justified x-dimension only */
int egatextM(unsigned char *str,unsigned xorigin,unsigned yorigin,
              unsigned tempcolor)
{
    int target = strlen(str);    /* string length               */
    int counter;

    if(!target)return 0;

    for(counter=0;counter<target;counter++){
        if(str[counter]<' '||str[counter]>'z')str[counter]=0;
        if(str[counter]==CRETURN)target=counter;
        }
    xorigin=(xorigin-(target*4));/* extrapolate the left edge   */
    egatext(str,xorigin,yorigin,tempcolor); /* pass to the usual function  */
    return target;

}


int egauptext(char *str, unsigned x, unsigned y, unsigned colorvalue)
{

    union REGS inregs, outregs;

    int scanline,byte,character,nibble;   /* flags etcetera */
    int counter;
    unsigned char *romfont=(unsigned char *) 0xffa6000el;
    /* a pointer to the 8 x 8 BITMAPPED font in the PC ROM    */

    int target = strlen(str);  /* string length               */

    if(!target)return 0;
    for(counter=0;counter<target;counter++){
        if(str[counter]<' '||str[counter]>'z')str[counter]=0;
        if(str[counter]==CRETURN)target=counter;
        }

     y=y+(target*8);
     inregs.h.ah = 0x0c;
     inregs.h.al = (char )colorvalue;
     inregs.h.bh = 0;



    for (scanline=0;scanline<8;scanline++) /* finish the current scanline
                                              before advancing to the next */
    {
     for (byte=0;byte<target;byte++)         /* run the scanline           */
     {                                       /* use the current character
                                                as an indices for the font */
      character = romfont[(str[byte]&0x7f)*8+scanline];
      if (character != 0)
          for (nibble=0;nibble<8;nibble++)
              if (character & 0x80>>nibble)
                       {
                         inregs.x.cx = x;
                         inregs.x.dx = y-byte*8-nibble;
                         int86(0x10,&inregs,&outregs);
                        }
        }

     x++;
    }
    return target;

}






int universalcolor=0xf;
int universalx=0, universaly=0;
void moveto(int x, int y)
{
    universalx=x;
    universaly=y;
}

void lineto(int x, int y)
{
   writeline(universalx,universaly,x,y,universalcolor);
   universalx=x;
   universaly=y;

}

void setegacolor(int col)
{
    universalcolor=col;

}



main(int argc, char **argv)
{

    FILE *fp;
    char *wordptr;
    int numdata[640];
    int ctr,lowlimit,hilimit;
    char titlebuf[128],verticalbuf[128],horizontalbuf[128],buf[128];
    int range,units,rate;
    int x,y,temp;
    unsigned y1;

    if(argc!=2)
    {
        puts("USAGE IS \"linegraf <data.fil>\"");
        exit(0);
    }


    if((fp=fopen(argv[1],"r"))==NULL)
    {
        perror(argv[1]);
        exit(0);
    }

    fgets(buf,128,fp);
    wordptr=strtok(buf,"\n");
    strcpy(titlebuf,buf);

    fgets(buf,128,fp);
    wordptr=strtok(buf,"\n");
    strcpy(verticalbuf,buf);

    fgets(buf,128,fp);
    wordptr=strtok(buf,"\n");
    strcpy(horizontalbuf,buf);

    ctr=0;
    lowlimit=32767;
    hilimit=-32768;

    while(fgets(buf,128,fp)!=NULL)
    {
       numdata[ctr]=atoi(buf);
       if(numdata[ctr]<lowlimit)lowlimit=numdata[ctr];
       if(numdata[ctr]>hilimit)hilimit=numdata[ctr];
       ctr++;
    }
    fclose(fp);

    range=(hilimit+1)-lowlimit;

    units=300;        /* vertical units */
    rate= 600/ctr;    /* horizontal units */


    if(setcrtmode(EGA)!=EGA)
    {
        puts("EGA REQUIRED...");
        exit(0);
    }


    /* draw the screen */
    flood(BLUE);
    linebox(0,0,639,349,CYAN);

    setegacolor(LCYAN);
    moveto(40,0);  /* do left side */
    lineto(40,300);
    lineto(639,300);

    setegacolor(CYAN);
    temp=0;
    x=40;
    while(temp<ctr)
    {
       moveto(x,300);
       lineto(x,305);
       x+=rate;
       temp++;
    }

    /* display the captions */
    x=40;
    egauptext(verticalbuf,1,1,YELLOW);
    egatext(horizontalbuf,x,310,YELLOW);
    temp=639-(strlen(titlebuf)*8);
    egatext(titlebuf,temp,310,BWHITE);

    sprintf(buf,"%d",hilimit);
    egatext(buf,12,0,WHITE);
    sprintf(buf,"%d",lowlimit);
    egatext(buf,12,300,WHITE);
    temp=0;

    /* draw the graph */
    setegacolor(LMAGENTA);
    while(temp<ctr)
    {
     y1=hilimit-numdata[temp];
     y=y1*units/range;
     if(temp==0)moveto(x,y);
     else lineto(x,y);
     x+=rate;
     temp++;
    }

    getch();
    setcrtmode(TEXT);
    exit(0);

}



